# Makefile for Windows NT and Digital Mars C++.
# DLLs are included in the root set under NT, but not under win32S.
# Use "nmake nodebug=1 all" for optimized versions of library, gctest and editor.

CPU= i386
CC=sc
CFLAGS=-Ar -mn -6 -w7 -w2

SRC1= if_not_there.c alpha_mach_dep.s rs6000_mach_dep.s sparc_mach_dep.s
SRC2= mips_mach_dep.s gc_private.h barrett_diagram README.OS2
SRC3= new_hblk.c gc_typed.h callprocs README.QUICK makefile.depend
SRC4= solaris_threads.c headers.c gc_mark.h if_mach.c gc_cpp.cc
SRC5= pc_excludes README.Mac README.amiga SCoptions.amiga SMakefile.amiga
SRC6= MacProjects.sit.hqx README.win32 PCR-Makefile gc_hdrs.h weakpointer.h
SRC7= test_cpp.cc gc_cpp.h typd_mlc.c stubborn.c setjmp_t.c dyn_load.c
SRC8= ptr_chck.c allchblk.c NT_MAKEFILE BCC_MAKEFILE mark_rts.c obj_map.c
SRC9= dbg_mlc.c gcc_support.c OS2_MAKEFILE add_gc_prefix.c checksums.c mark.c
SRC10= MacOS.c mach_dep.c README.debugging finalize.c blacklst.c
SRC11= pcr_interface.c os_dep.c malloc.c misc.c gc_priv.h EMX_MAKEFILE gc.h
SRC12= gc.man README.rs6000 README GCC_Makefile config.h test.c alloc.c reclaim.c
SRC13= real_malloc.c buildit.bat

OBJS= alloc.obj reclaim.obj allchblk.obj misc.obj mach_dep.obj \
	os_dep.obj mark_rts.obj headers.obj mark.obj obj_map.obj \
	blacklst.obj finalize.obj new_hblk.obj dbg_mlc.obj malloc.obj \
	stubborn.obj dyn_load.obj typd_mlc.obj ptr_chck.obj gc_cpp.obj

all: gctest.exe test_cpp.exe

DEFINES=-DSMALL_CONFIG -DOPERATOR_NEW_ARRAY -DSILENT

.c.obj:
	$(CC) -c $(CFLAGS) $(DEFINES) $*

.cpp.obj:
	$(CC) -c $(CFLAGS) -Aa $(DEFINES) $*

$(OBJS) test.obj: gc_priv.h gc_hdrs.h gc.h

gc.lib : $(OBJS) makefile
	del gc.lib
	*lib gc /c/noi +alloc+reclaim+allchblk+misc+mach_dep+\
	os_dep+mark_rts+headers+mark+obj_map+\
	blacklst+finalize+new_hblk+dbg_mlc+malloc+\
	stubborn+dyn_load+typd_mlc+ptr_chck+gc_cpp;

gctest.exe: test.obj gc.lib
#  This produces a "GUI" applications that opens no windows and writes to the log file
#  "gc.log".  This is done to make the result runnable under win32s.
	$(CC) test.obj gc.lib kernel32.lib user32.lib -L/map

gc_cpp.obj: gc_cpp.h gc.h

gc_cpp.cpp: gc_cpp.cc
	copy gc_cpp.cc gc_cpp.cpp

test_cpp.cpp: test_cpp.cc
	copy test_cpp.cc test_cpp.cpp

# This generates the C++ test executable.  The executable expects
# a single numeric argument, which is the number of iterations.
# The output appears in the file "gc.log".
test_cpp.exe: test_cpp.obj gc_cpp.h gc.h gc.lib
	$(CC) test_cpp.obj gc.lib kernel32.lib user32.lib


clean:
	del *.obj
	del *.exe
	del *.map
	del *.log

win32.mak : makefile
	copy makefile win32.mak

zip : win32.mak
	zip32 -u gc $(SRC1)
	zip32 -u gc $(SRC2)
	zip32 -u gc $(SRC3)
	zip32 -u gc $(SRC4)
	zip32 -u gc $(SRC5)
	zip32 -u gc $(SRC6)
	zip32 -u gc $(SRC7)
	zip32 -u gc $(SRC8)
	zip32 -u gc $(SRC9)
	zip32 -u gc $(SRC10)
	zip32 -u gc $(SRC11)
	zip32 -u gc $(SRC12)
	zip32 -u gc $(SRC13)


